import { html, ref, repeat } from '@microsoft/fast-element';
export const previewComponents = (prefix) => html `
  <template>
    <${prefix}-design-system-provider ${ref('provider')}>
      <div class="wrapper">
        <div class="column">
          <div class="row">
            <div class="column">
              <${prefix}-breadcrumb role="navigation">
                <${prefix}-breadcrumb-item href="#"><${prefix}-icon name="folder" size="md" variant="regular" slot="start"></${prefix}-icon></${prefix}-breadcrumb-item>
                <${prefix}-breadcrumb-item href="#">Item 1</${prefix}-breadcrumb-item>
                <${prefix}-breadcrumb-item href="#">Item 2</${prefix}-breadcrumb-item>
                <${prefix}-breadcrumb-item>Item 3</${prefix}-breadcrumb-item>
              </${prefix}-breadcrumb>
              <${prefix}-badge :fill="${(x) => x.badgeAppearanceAccent}" color="${(x) => x.badgeText}" class="row-padding">Badge</${prefix}-badge>
              <${prefix}-badge fill="${(x) => x.badgeAppearanceNeutral}" color="${(x) => x.badgeText}">Badge</${prefix}-badge>
            </div>
            <div class="column">
              <div class="flex-row">
                <${prefix}-button href="#" :appearance="${(x) => x.buttonAppearanceAccent}">Button</${prefix}-button>
                <${prefix}-button href="#" :appearance="${(x) => x.buttonAppearanceNeutral}">Button</${prefix}-button>
                <${prefix}-button href="#" :appearance="${(x) => x.buttonAppearanceOutline}">Button</${prefix}-button>
                <${prefix}-button :appearance="${(x) => x.buttonAppearanceAccent}">
                  Button
                  <${prefix}-icon name="edit" size="md" slot="start"></${prefix}-icon>
                </${prefix}-button>
                <${prefix}-flipper
                role="button"
                tabindex="-1"
                class="previous"
                aria-hidden="true"
                direction="previous"
              ></${prefix}-flipper>
              <${prefix}-flipper
                role="button"
                tabindex="-1"
                class="next"
                aria-hidden="true"
                direction="next"
              ></${prefix}-flipper>
              <${prefix}-switch
                role="switch"
                checked
                aria-checked="true"
                aria-disabled="false"
                tabindex="0"
              ></${prefix}-switch>
              </div>

            </div>
          </div>

          <div class="row">
            <div class="column">
              <div class="flex-row">
                <${prefix}-radio-group role="radiogroup" orientation="horizontal">
                  <${prefix}-radio
                    checked
                    role="radio"
                    aria-checked="true"
                    aria-required="false"
                    aria-disabled="false"
                    tabindex="0"
                  >
                    Radio 1
                  </${prefix}-radio>
                  <${prefix}-radio
                    role="radio"
                    aria-checked="false"
                    aria-required="false"
                    aria-disabled="false"
                    tabindex="-1"
                  >
                    Radio 2
                  </${prefix}-radio>
                </${prefix}-radio-group>
                <${prefix}-checkbox
                  role="checkbox"
                  checked
                  aria-checked="true"
                  aria-required="false"
                  aria-disabled="false"
                  tabindex="0"
                >
                  Checkbox
                </${prefix}-checkbox>
                <${prefix}-checkbox
                  role="checkbox"
                  aria-checked="false"
                  aria-required="false"
                  aria-disabled="false"
                  tabindex="0"
                >
                  Checkbox
                </${prefix}-checkbox>
              </div>
            </div>
            <div class="column">
              <${prefix}-disclosure appearance="accent" title="Open Disclosure">
                <div>Created by writer Gardner Fox and artist Harry Lampert, the original Flashfirst appeared
                in Flash Comics #1 (cover date January 1940/release monthNovember 1939). Nicknamed the
                "Scarlet Speedster", all incarnations of theFlash possess "super speed", which includes
                the ability to run, move, andthink extremely fast, use superhuman reflexes, and seemingly
                violatecertain laws of physics.</div>
              </${prefix}-disclosure>
            </div>
          </div>

          <div class="row">
            <div class="column">
              <div class="flex-row">
                <div class="flex-column">
                  <div class="label"> ComboBox</div>
                  <${prefix}-combobox autocomplete="both">
                    <${prefix}-option>Christopher Eccleston</${prefix}-option>
                    <${prefix}-option>David Tenant</${prefix}-option>
                    <${prefix}-option>Matt Smith</${prefix}-option>
                    <${prefix}-option>Peter Capaldi</${prefix}-option>
                    <${prefix}-option>Jodie Whittaker</${prefix}-option>
                  </${prefix}-combobox>
                </div>
                <div class="flex-column">
                  <div class="label"> Select</div>
                  <${prefix}-select>
                    <${prefix}-option>Christopher Eccleston</${prefix}-option>
                    <${prefix}-option>David Tenant</${prefix}-option>
                    <${prefix}-option>Matt Smith</${prefix}-option>
                    <${prefix}-option>Peter Capaldi</${prefix}-option>
                    <${prefix}-option>Jodie Whittaker</${prefix}-option>
                  </${prefix}-select>
                </div>
              </div>
            </div>
            <div class="column">
              <${prefix}-segmented-control appearance="primary">
                <label slot="label">Primary Segment Control (label slot)</label>
                <${prefix}-segmented-item>Segmented Item</${prefix}-segmented-item>
                <${prefix}-segmented-item>Segmented Item</${prefix}-segmented-item>
                <${prefix}-segmented-item>Segmented Item</${prefix}-segmented-item>
              </${prefix}-segmented-control>
            </div>
          </div>


          <div class="row">
            <div class="column">
              <div class="row">
                <${prefix}-text-field
                  placeholder="Text field"
                  aria-label="Example text field"
                  type="text"
                >
                Label
                </${prefix}-text-field>
                <${prefix}-number-field class="row-padding" placeholder="number" withFormatting>Number Field</${prefix}-number-field>
                <${prefix}-date-picker class="row-padding" label="Date Picker" value="01-01-2023"></${prefix}-date-picker>
              </div>
            </div>
            <div class="column">
              <div class="flex-row">
                <${prefix}-button  appearance="${(x) => x.buttonAppearanceAccent}" @click="${(x) => x.showDialog('modal')}">Show Modal</${prefix}-button>
                <${prefix}-button  appearance="${(x) => x.buttonAppearanceAccent}" @click="${(x) => x.showDialog('dialog')}">Show Dialog</${prefix}-button>
                <${prefix}-multiselect class="row-padding" name="Countries" :options="${(x) => x.countries}" search=true>
                </${prefix}-multiselect>
                <${prefix}-modal ${ref('modal')} style="--dialog-max-width:557px;">
                  <h5 slot="top">Modal Title</h5>
                  <p>
                    Lorem ipsum dolor sit amet consectetur adipisicing elit. Quis similique iste ab sed
                    voluptatem ut suscipit tenetur distinctio? Quo est debitis pariatur qui quisquam
                    repudiandae at atque et quibusdam rerum, reprehenderit sed laborum officiis
                    distinctio dolorum temporibus aperiam dolor consequatur perferendis aspernatur fugit
                    repellendus asperiores, voluptas illo? Voluptatum, atque quidem?
                  </p>
                  <${prefix}-button appearance="${(x) => x.buttonAppearanceAccent}" slot="bottom" @click="${(x) => x.closeDialog('modal')}">Close</${prefix}-button>
                </${prefix}-modal>
                <${prefix}-dialog  ${ref('dialog')} style="--dialog-max-width:557px;">
                  <div slot="top">Dialog Title</div>
                  <p>Some Text in a Dialog</p>
                  <p>Lorem ipsum dolor sit amet consectetur adipisicing elit. Quis similique iste ab sed
                    voluptatem ut suscipit tenetur distinctio? Quo est debitis pariatur qui quisquam repudiandae
                    at atque et quibusdam rerum, reprehenderit sed laborum officiis distinctio dolorum
                    temporibus aperiam dolor consequatur perferendis aspernatur fugit repellendus asperiores,
                    voluptas illo? Voluptatum, atque quidem?</p>
                      <${prefix}-button  appearance="${(x) => x.buttonAppearanceAccent}" slot="bottom" @click="${(x) => x.closeDialog('dialog')}">
                      Close this dialog
                      </${prefix}-button>
                </${prefix}-dialog>
                <div ${ref('errorDialogContainer')}></div>
              </div>
            </div>
          </div>

          <div class="row">
            <div class="column">
              <${prefix}-slider
                style="margin-bottom: 20px;"
                role="slider"
                class="horizontal"
                tabindex="0"
                aria-valuenow="10"
                aria-valuemin="0"
                aria-valuemax="100"
                aria-orientation="horizontal"
                min="0"
                max="100"
                step="10"
                value="70"
                orientation="horizontal"
                mode="single-value"
              >
              <${prefix}-slider-label position="10">10%</${prefix}-slider-label>
              <${prefix}-slider-label position="50">50%</${prefix}-slider-label>
              <${prefix}-slider-label position="80">80%</${prefix}-slider-label>
              <${prefix}-slider-label position="100">100%</${prefix}-slider-label>
              </${prefix}-slider>
            </div>
            <div class="column">
              <div class="flex-row">
                <${prefix}-dropdown-menu name="Dropdown menu" :items="${(x) => x.dropDownMenuItems}"></${prefix}-dropdown-menu>
                
                <${prefix}-connection-indicator show-label></${prefix}-connection-indicator>
              </div>
            </div>
          </div>

          <div class="row">
            <div class="column">
              <${prefix}-accordion>
                <${prefix}-accordion-item slot="item" id="accordion-1" class="expanded">
                  Accordion one content
                  <div slot="heading">Accordion one</div>
                </${prefix}-accordion-item>
                <${prefix}-accordion-item slot="item" id="accordion-2">
                  Accordion two content
                  <div slot="heading">Accordion two</div>
                </${prefix}-accordion-item>
                <${prefix}-accordion-item slot="item" id="accordion-3">
                  Accordion three content
                  <div slot="heading">Accordion three</div>
                </${prefix}-accordion-item>
                <${prefix}-accordion-item slot="item" id="accordion-4">
                  Accordion four content
                  <div slot="heading">Accordion four</div>
                </${prefix}-accordion-item>
              </${prefix}-accordion>
            </div>
            
            <div class="column">
              <${prefix}-tree-view role="tree">
                <${prefix}-tree-item
                  role="treeitem"
                  tabindex="0"
                  aria-expanded="true"
                  expanded
                  selected
                  class="nested"
                >
                  Tree item 1
                  <${prefix}-tree-item slot="item" role="treeitem">Tree item 1 - 1</${prefix}-tree-item>
                </${prefix}-tree-item>
                <${prefix}-tree-item role="treeitem" tabindex="0" aria-expanded="false" class="nested">
                  Tree item 2
                  <${prefix}-tree-item slot="item" role="treeitem">Tree item 2 - 1</${prefix}-tree-item>
                </${prefix}-tree-item>
                <${prefix}-tree-item role="treeitem" class="nested">Tree item 3</${prefix}-tree-item>
              </${prefix}-tree-view>
            </div>
          </div>

          <div class="row">
            <div class="column">
              <${prefix}-progress role="progressbar"></${prefix}-progress>
            </div>
            <div class="column">
              <${prefix}-progress-ring role="progressbar"></${prefix}-progress-ring>
            </div>
          </div>
          <div class="row">
            <div class="column">
              <${prefix}-menu>
                <${prefix}-menu-item>Menu item 1
                  <${prefix}-menu slot="submenu">
                    <${prefix}-menu-item>Menu item 1</${prefix}-menu-item>
                    <${prefix}-menu-item>Menu item 2</${prefix}-menu-item>
                    <${prefix}-menu-item>Menu item 3</${prefix}-menu-item>
                  </${prefix}-menu>
                </${prefix}-menu-item>
                <${prefix}-menu-item>Menu item 2</${prefix}-menu-item>
                <${prefix}-menu-item>Menu item 3</${prefix}-menu-item>
              </${prefix}-menu>
            </div>
            <div class="column">
              <${prefix}-card>
                <${prefix}-tabs>
                  <span part="start" class="start" slot="start">Blotter</span>
                  <${prefix}-tab>Tab 1</${prefix}-tab>
                  <${prefix}-tab slot="tab">Tab 2</${prefix}-tab>
                  <${prefix}-tab slot="tab">Tab 3</${prefix}-tab>
                  <${prefix}-tab slot="tab">Tab 4</${prefix}-tab>
                  <${prefix}-tab-panel slot="tabpanel">
                    <${prefix}-tabs appearance="secondary">
                      <${prefix}-tab appearance="secondary" slot="tab">Nested Tab 1</${prefix}-tab>
                      <${prefix}-tab appearance="secondary" slot="tab">Nested Tab 2</${prefix}-tab>
                      <${prefix}-tab-panel slot="tabpanel">Nested Tab Panel 1</${prefix}-tab-panel>
                      <${prefix}-tab-panel slot="tabpanel">Nested Tab Panel 2</${prefix}-tab-panel>
                    </${prefix}-tabs>
                  </${prefix}-tab-panel>
                  <${prefix}-tab-panel slot="tabpanel">Tab Panel 2</${prefix}-tab-panel>
                  <${prefix}-tab-panel slot="tabpanel">Tab Panel 3</${prefix}-tab-panel>
                  <${prefix}-tab-panel slot="tabpanel">Tab Panel 4</${prefix}-tab-panel>
                </${prefix}-tabs>
              </${prefix}-card>
            </div>
          </div>

          <div class="row">
            <div class="column">
              <${prefix}-card style="padding:20px;">
                <${prefix}-card style="padding:20px;">
                  <${prefix}-card>
                    <h3 style="padding-left: 8px;">Divider</h3>
                    <${prefix}-divider></${prefix}-divider>
                  </${prefix}-card>
                </${prefix}-card>
              </${prefix}-card>
            </div>
            <div class="column">
              <${prefix}-card style="padding:20px;">
                <h3>Skeleton</h3>
                <${prefix}-skeleton style="width: 50px; height: 50px;" shape="circle"></${prefix}-skeleton>
                <${prefix}-skeleton style="border-radius: 4px; margin-top: 10px; height: 10px;" shape="rect"></${prefix}-skeleton>
                <${prefix}-skeleton style="border-radius: 4px; margin-top: 10px; height: 10px;" shape="rect"></${prefix}-skeleton>
                <${prefix}-skeleton style="border-radius: 4px; margin-top: 10px; height: 10px;" shape="rect"></${prefix}-skeleton>
                <${prefix}-skeleton style="border-radius: 4px;width: 75px;height: 30px;margin-top: 20px;margin-bottom: 10px;"
                  shape="rect"></${prefix}-skeleton>
              </${prefix}-card>
            </div>
          </div>

          <div class="row">
            <div class="column">
              <${prefix}-horizontal-scroll class="horizontal-scroll">
                ${repeat((x) => x.cards, html `
                    <${prefix}-card class="card-padding">
                      Card number ${(x) => x}
                      <${prefix}-button>A button</${prefix}-button>
                    </${prefix}-card>
                  `)}
              </${prefix}-horizontal-scroll>  
            </div>
            <div class="column">
              <${prefix}-listbox>
                <${prefix}-option>Option 1</${prefix}-option>
                <${prefix}-option>Option 2</${prefix}-option>
                <${prefix}-option>Option 3</${prefix}-option>
              </${prefix}-listbox>
            </div>
          </div>
          <div class="row">
            <div class="column">
              <${prefix}-toolbar>
                <span slot="label">Toolbar</span> 
                <${prefix}-checkbox>Checkbox</${prefix}-checkbox>
                <${prefix}-checkbox>Checkbox</${prefix}-checkbox>
                <${prefix}-button slot="end"><${prefix}-icon name="power-off" slot="start"></${prefix}-icon> Sign Out</${prefix}-button>
                <${prefix}-select>
                  <${prefix}-option value="1">Option 1</${prefix}-option>
                  <${prefix}-option value="2">Option 2</${prefix}-option>
                  <${prefix}-option value="3">Option 3</${prefix}-option>
                </${prefix}-select>
              </${prefix}-toolbar>
            </div>
            <div class="column">
              <${prefix}-banner  ${ref('banner')}>
                <div slot="content">Lorem ipsum dolor sit amet consectetur adipisicing elit. Lorem ipsum dolor sit amet.
      Lorem, ipsum dolor.</div>
                <${prefix}-button slot="action" @click="${(x) => x.dismissBanner()}" :appearance="${(x) => x.buttonAppearanceText}">
                  Ignore
                </${prefix}-button>
                <${prefix}-button slot="action" :appearance="${(x) => x.buttonAppearanceText}">
                  Diagnose
                </${prefix}-button>
              </${prefix}-banner>
            </div>
          </div>
          <div class="row">
            <div class="column">
              <${prefix}-stepper>
                <${prefix}-stepper-tab>stepper 1</${prefix}-stepper-tab>
                <${prefix}-stepper-tab>stepper 2</${prefix}-stepper-tab>
                <${prefix}-stepper-tab>stepper 3</${prefix}-stepper-tab>
                <${prefix}-stepper-tab>stepper 4</${prefix}-stepper-tab>
                <${prefix}-stepper-tab-panel>Stepper Panel 1</${prefix}-stepper-tab-panel>
                <${prefix}-stepper-tab-panel>Stepper Panel 2</${prefix}-stepper-tab-panel>
                <${prefix}-stepper-tab-panel>Stepper Panel 3</${prefix}-stepper-tab-panel>
                <${prefix}-stepper-tab-panel>Stepper Panel 4</${prefix}-stepper-tab-panel>
              </${prefix}-stepper>
            </div>
            <div class="column">
              <${prefix}-toast notify="critical">
                <h6 slot="top">Toast title</h6>
                <span slot="content">Lorem ipsum dolor sit amet consectetur adipisicing elit. Lorem ipsum dolor sit amet. Lorem, ipsum dolor.</span>
                <span slot="date">Today 14:28</span>
                <${prefix}-button :appearance="${(x) => x.buttonAppearanceAccent}" slot="bottom">Close notification</${prefix}-button>
              </${prefix}-toast>
            </div>
          </div>
        </div>
      </div>
    </${prefix}-design-system-provider>
  </template>
`;
export const PreviewComponentsTemplate = html `
  ${(x) => previewComponents(x.prefix)}
`;
